*DECK BEXSEL
      SUBROUTINE BEXSEL(IPRES,NCH,NX,NY,NREG,MIX,IXN,IYN,
     +              BEXIT,IBX,ZONE)
*
*-----------------------------------------------------------------------
*
*  SORTS CHANNEL ACCORDING TO EXIT BURNUP AND GIVES ZONE NUMBERS AFFECTE
*
* INPUT PARAMETERS:
*  IPRES  : ADDRESS OF THE MAP LINKED LIST OR XSM FILE.
*  NCH    : NUMBER OF CHANNELS.
*  NX     : NUMBER OF X-ELEMENTS.
*  NY     : NUMBER OF Y-ELEMENTS.
*  NY     : TOTAL NUMBER OF REGIONS.
*  MIX    : FUEL MAP BUNDLE INDEX. DIMENSION MIX(NREG)
*  NZONE  : NUMBER OF ZONES.
*  ZONE   : ZONE INDEX. DIMENSION ZONE(NCH)
*  BEXIT  : EXIT BURNUPS. DIMENSION BEXIT(NCH)
*
* OUTPUT PARAMETERS:
*  IPRES  : ADDRESS OF THE MAP LINKED LIST OR XSM FILE.
*
*
*-------------------------------------- AUTHOR: E. VARIN 31/07/96 ---
*
      IMPLICIT NONE
      INTEGER    IPRES
      INTEGER    NCH,NX,NY,NREG,NZONE,ICH,IX,IY
      REAL       BEXIT(NCH)
      CHARACTER  XNAM*4,YNAM*4,TEXT4*4
      INTEGER    MIX(NREG),IXN(NX),IYN(NY),ZONE(NCH),IBX(NCH)
*
C LOCAL
      INTEGER I,J
*
*     RECOVER INFORMATION IN FUEL MAP OBJECT
*
      CALL LCMGET(IPRES,'CONTR-ZONE',ZONE)
      CALL LCMGET(IPRES,'BURN-EXIT',BEXIT)
      CALL LCMSIX(IPRES,'GEO:RES',1)
      CALL LCMGET(IPRES,'MIX',MIX)
      CALL LCMSIX(IPRES,' ',0)
      CALL LCMGET(IPRES,'XNAME',IXN)
      CALL LCMGET(IPRES,'YNAME',IYN)
* SORT BEXIT
      CALL SORTIN(NCH,BEXIT,IBX)
* FIND NUMBER OF ZONES
      NZONE = 0
      DO 5 I=1,NCH
        NZONE = MAX(NZONE,ZONE(I))
    5 CONTINUE
*
*  LIST VALUES
      DO 10 J=NCH,1,-1
      DO 20 I=1,NREG
        IF(MIX(I).EQ.IBX(J)) THEN
           ICH = I
           IY = ICH/NX + 1
           IX = ICH - NX*(IY-1)
           WRITE(XNAM,'(A4)') IXN(IX)
           WRITE(YNAM,'(A4)') IYN(IY)
           WRITE(TEXT4,'(A1,A2)')  YNAM(1:1),XNAM(1:2)
           WRITE(6,1000) BEXIT(IBX(J)),TEXT4,ZONE(IBX(J)),
     +                                       ZONE(IBX(J))+NZONE,IBX(J)
        ENDIF
  20  CONTINUE
  10  CONTINUE
*
 1000 FORMAT('EXIT BURN ',F8.1,' CHANNEL ',A4,' ZONES ',I3,1X,I3,1X,I3)
      RETURN
      END
