*DECK FOLCAL
      SUBROUTINE FOLCAL(IPRES,NCH,NK,TIME,POWR,WINT,WEIGHT,IMOD)
*
**********************************************************************
*
*     THIS SUBROUTINE COMPUTES NEW BURNUP ACCORDING TO EVOLUTION
*     TIME IN DAYS.
*
*     CETTE SOUS ROUTINE CALCULE L'INCREMENT DE BURNUP SELON LE TEMPS
*     DE RESIDENCE DE CHAQUE GRAPPE
*
*
*-------------------------------------- AUTHOR: E. VARIN  95/10/03 ---
*
      IMPLICIT NONE
*
*  LOCAL VARIABLES
*
      INTEGER I,J,IPRES
      INTEGER NCH,NK,IMOD
      REAL    POWR(NCH,NK),WINT(NCH,NK),WEIGHT
*
      REAL    TIME
*
      CALL LCMSIX(IPRES,' ',0)
      CALL LCMGET(IPRES,'BURN-DEB',WINT(1,1))
      CALL LCMGET(IPRES,'POWER-BUN',POWR(1,1))
      WRITE(6,*) ' EVOLUTION ',TIME,' DAY '
*
*     CALCUL DES INCREMENTS DE BURNUP
*
      DO 15 I=1,NCH
        DO 16 J=1,NK
          WINT(I,J) = WINT(I,J) + POWR(I,J)*TIME/WEIGHT
 16     CONTINUE
 15   CONTINUE
*
      CALL LCMPUT(IPRES,'BURN-DEB',NCH*NK,2,WINT(1,1))
      IF( IMOD.EQ.2 .OR. IMOD.EQ.3 )THEN
        CALL LCMSIX(IPRES,' ',0)
        CALL LCMGET(IPRES,'BURN-END',WINT(1,1))
*
*     CALCUL DES INCREMENTS DE BURNUP
*
        DO 25 I=1,NCH
          DO 26 J=1,NK
            WINT(I,J) = WINT(I,J) + POWR(I,J)*TIME/WEIGHT
 26       CONTINUE
 25     CONTINUE
      CALL LCMPUT(IPRES,'BURN-END',NCH*NK,2,WINT(1,1))
      ENDIF
*
      RETURN
      END
