*DECK MAKIND
      SUBROUTINE MAKIND(IPRES,IPIND,NIND,NCH,NK,LX,LY,LZ,
     +   INDEX,INDCPO,INDGEO)
C
C THIS SUBOUTINE MODIFIES L_INDEX FOR FUEL MAP
C
C INPUTS -
C          IPIND : IPLIST OF L_IND
C          IPRES  : IPLIST OF L_MAP
C          NX : NUMBER OF NODES IN X DIRECTION IN MAP
C          NY : NUMBER OF NODES IN Y DIRECTION IN MAP
C          NZ : NUMBER OF NODES IN Z DIRECTION IN MAP
C          LX : NUMBER OF NODES IN X DIRECTION IN GEOM
C          LY : NUMBER OF NODES IN Y DIRECTION IN GEOM
C          LZ : NUMBER OF NODES IN Z DIRECTION IN GEOM
C OUTPUTS -
C          INDEX : INDEX OF NODES BETWEEN MAP AND GEOM
*
*-------------------------------------- AUTHOR: E. VARIN 30/08/95 ---
C
*
*      IMPLICIT NONE
*
      INTEGER IPIND,IPRES
      INTEGER NK,NCH,LX,LY,LZ,NIND
      INTEGER INDEX(LX*LY*LZ),INDCPO(NCH*NK),INDGEO(NIND)
*
C LOCAL
      INTEGER I,J
*
*     RECUPERATION DES INFORMATIONS
*
      CALL LCMGET(IPIND,'MIX',INDGEO)
*
*     CREATION DES NUMEROS DE COMPO SUR GEO DU RESEAU
*
      DO 10 I=1,NCH*NK
          INDCPO(I) = 0
 10   CONTINUE
*
      DO 20 I=1,LX*LY*LZ
         IF (INDEX(I).NE.0) THEN
           J = INDEX(I)
           INDCPO(J) = INDGEO(I)
         ENDIF
  20  CONTINUE
*
      DO 30 I=1,LX*LY*LZ
         IF (INDEX(I).NE.0) THEN
           INDGEO(I) = - INDEX(I)
         ENDIF
  30  CONTINUE
*
      RETURN
      END
