*DECK SMCION
      SUBROUTINE SMCION(DT,RESP,REF,PLNL,TLG)
*
*-----------------------------------------------------------------------
*
*     THIS MODULE COMPUTES ION CHAMBER RESPONSES
*
*     CE MODULE PERMET DE CALCULER LES LECTURES DES
*     CHAMBRES D'ION
*
*     INPUT:
*              DT     : REAL
*                       SIMULATION TIME STEP
*              PLNL   : REAL
*                       PREVIOUS TIME LOGARITHMIC RESPONSE
*              REF    : REAL
*                       REFERENCE VALUE
*              RESP   : REAL
*                       LINEAR DETECTOR RESPONSE
*     OUTPUT:
*              RESP   : REAL
*                       LOGARITHMIC DETECTOR RESPONS
*              TLG    : REAL
*                       DETECTOR LOGARITHMIC RATE
*
*
*     ROUTINE FROM SMOKIN-G2, INCORPORATED IN DONJON
*
*
*-------------------------------------------------------------------
*
*
      REAL  DT,PLNL,RESP,TLG,REF
*
*     ION CHAMBER REPONSE
*
      RESP = LOG10(RESP/REF)
      TLG = (RESP-PLNL)/DT
*
      RETURN
      END
