*DECK SRLIMT
      SUBROUTINE SRLIMT(X,LIMINF,LIMSUP,N)
*
*-----------------------------------------------------------------------
*
*     LIMITS THE N VALUES OF VECTOR X BETWEEN LIMSUP AND LIMINF
*
*     CETTE ROUTINE LIMITE LES N VALEURS DE X
*     ENTRE LIMINF ET LIMSUP
*
*     INPUT  :
*              X : REAL
*                  VECTOR TO PROCESS
*         LIMINF : REAL
*                  LOWER LIMIT
*         LIMSUP : REAL
*                  HIGHER LIMIT
*              N : ENTIER
*                  NUNBER OF ELEMENTS
*     OUTPUT  :
*              X : REAL
*
*
*     ROUTINE FROM SMOKIN-G2, INCORPORATED IN DONJON
*
*--------------------------------------------------------------------
*
*      IMPLICIT NONE
      INTEGER  N,I
      REAL     X(N),LIMINF,LIMSUP
*
      DO 10 I=1,N
*
        IF (X(I).LT.LIMINF) THEN
           X(I) = LIMINF
        ELSEIF (X(I).GT.LIMSUP) THEN
           X(I) = LIMSUP
        ENDIF
*
 10   CONTINUE
      RETURN
      END
