      SUBROUTINE LCMCL(IPLIST,IACT)
*
*----------------------------------------------------------------------
*
* CLOSE, DESTROY OR ERASE A LINKED LIST.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE EXISTING LINKED LIST.
*    IACT : =1 TO CLOSE; =2 TO DESTROY; =3 TO ERASE AND CLOSE.
*
*------------------------------------ AUTHOR: A. HEBERT ; 21/10/93 ----
*
      PARAMETER (LHASH=251)
      PARAMETER (IHEAD=0,IHNAM=1,INEXT=4,IFATH=5,IDIR=6,INEXT0=7,
     1 IFATH0=8,IMODE=9)
      PARAMETER (JDATA=LHASH+2,JJTYP=LHASH+4,JFATH=LHASH+5,JCMT=LHASH+9)
      CHARACTER CMT*12,HSMG*131
      LOGICAL   LCAFAL
      COMMON IBASE(1)
      PARAMETER (LCAFAL=.FALSE.)
*
      IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         IF(IACT.EQ.3) THEN
            WRITE(HSMG,'(21HLCMCL: THE XSM FILE '',3A4,11H'' CANNOT BE,
     1      8H ERASED.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
            CALL XABORT(HSMG)
         ENDIF
         CALL XSMCL(IPLIST,IACT)
         RETURN
      ELSE IF(IBASE(IPLIST+IHEAD).NE.100) THEN
         WRITE(HSMG,'(24HLCMCL: THE LINKED LIST '',3A4,11H'' HAVE THE ,
     1   13HWRONG HEADER.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(24HLCMCL: THE LINKED LIST '',3A4,11H'' IS ALREAD,
     1   9HY CLOSED.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ENDIF
      CALL LCMVAL(IPLIST,' ')
      IF((IACT.EQ.1).AND.(IBASE(IPLIST+IMODE).EQ.2)) THEN
*        IF THE LINKED LIST IS OPEN IN READ-ONLY MODE, RETURN TO THE
*        DIRECTORY ACTIVE AT THE OPEN TIME.
         IBASE(IPLIST+IFATH)=IBASE(IPLIST+IFATH0)
         IBASE(IPLIST+INEXT)=IBASE(IPLIST+INEXT0)
         IPNODE=IBASE(IPLIST+IFATH)
         IF(IPNODE.EQ.-1) THEN
            IBASE(IPLIST+IDIR)=-1
         ELSE
            DO 10 I=1,IBASE(IPNODE+1)
            IF(IBASE(IPLIST+INEXT).EQ.IBASE(IPNODE+10*(I-1)+JDATA)) THEN
               IBASE(IPLIST+IDIR)=I
               GO TO 20
            ENDIF
   10       CONTINUE
            WRITE(HSMG,'(42HLCMCL: UNABLE TO FIND A PARENT DIRECTORY I,
     1      19HN THE LINKED LIST '',3A4,2H''.)') (IBASE(IPLIST+IHNAM+I),
     2      I=0,2)
            CALL XABORT(HSMG)
         ENDIF
   20    IBASE(IPLIST+IMODE)=0
         RETURN
      ELSE IF(IACT.EQ.1) THEN
         IBASE(IPLIST+IMODE)=0
         RETURN
      ELSE IF((IACT.EQ.2).OR.(IACT.EQ.3)) THEN
*        DESTROY OR ERASE THE LINKED LIST.
         IF(IBASE(IPLIST+IMODE).EQ.2) THEN
            WRITE(HSMG,'(42HLCMCL: CANNOT DESTROY OR ERASE THE LINKED ,
     1      6HLIST '',3A4,25H'' OPEN IN READ-ONLY MODE.)')
     2      (IBASE(IPLIST+IHNAM+I),I=0,2)
            CALL XABORT(HSMG)
         ENDIF
         CALL LCMSIX(IPLIST,' ',0)
   30    IPNODE=IBASE(IPLIST+INEXT)
         IF(IPNODE.EQ.0) GO TO 50
         I=0
   40    I=I+1
         IF(I.GT.IBASE(IPNODE+1)) GO TO 50
         IF((IBASE(IPNODE+10*(I-1)+JJTYP).EQ.0).AND.(
     1      IBASE(IPNODE+10*(I-1)+JDATA).NE.0)) THEN
            IBASE(IPNODE+10*(I-1)+JFATH)=IBASE(IPLIST+IFATH)
            CALL LCMCAR(CMT,LCAFAL,IBASE(IPNODE+10*(I-1)+JCMT))
            CALL LCMSIX(IPLIST,CMT,1)
            GO TO 30
         ELSE IF(IBASE(IPNODE+10*(I-1)+JJTYP).EQ.-99) THEN
            GO TO 40
         ELSE IF(IBASE(IPNODE+10*(I-1)+JJTYP).NE.0) THEN
            CALL RLSARA(IBASE(IBASE(IPNODE+10*(I-1)+JDATA)))
         ENDIF
         GO TO 40
   50    IF((IBASE(IPLIST+IFATH).EQ.-1).AND.(IACT.EQ.2)) THEN
*           DESTROY THE LINKED-LIST.
            IBASE(IPLIST+IHEAD)=0
            IPNODE=IBASE(IPLIST+INEXT)
            IF(IPNODE.NE.0) CALL RLSARA(IBASE(IPNODE))
            CALL RLSARA(IBASE(IPLIST))
            IPLIST=0
         ELSE IF(IBASE(IPLIST+IFATH).EQ.-1) THEN
*           ERASE THE LINKED-LIST.
            IBASE(IPLIST+INEXT)=0
            IBASE(IPLIST+IDIR)=-1
            IBASE(IPLIST+IMODE)=0
         ELSE
            I=IBASE(IPLIST+IDIR)
            CALL LCMSIX(IPLIST,' ',2)
            IF(IPNODE.NE.0) CALL RLSARA(IBASE(IPNODE))
            IPNODE=IBASE(IPLIST+INEXT)
            GO TO 40
         ENDIF
         RETURN
      ELSE
         WRITE(HSMG,'(23HLCMCL: INVALID ACTION (,I3,15H) ON THE LINKED,
     1   7H LIST '',3A4,2H''.)') IACT,(IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ENDIF
      END
