      SUBROUTINE LCMDEL(IPLIST,NAMP)
*
*-----------------------------------------------------------------------
*
* DELETE AN ENTRY IN THE LINKED LIST.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LINKED LIST.
*    NAMP : CHARACTER*12 NAME OF THE BLOCK TO DELETE.
*
*------------------------------------- AUTHOR: A. HEBERT ; 08/11/93 ----
*
      PARAMETER (LHASH=251)
      INTEGER PTMP,PDATA
      PARAMETER (IHEAD=0,IHNAM=1,INEXT=4,IFATH=5,IDIR=6,IMODE=9)
      PARAMETER (JDATA=LHASH+2,JJLON=LHASH+3,JJTYP=LHASH+4,JCMT=LHASH+9)
      CHARACTER NAMP*(*),NAMT*12,TEXT12*12,HSMG*131
      INTEGER INAMT(3)
      LOGICAL LCATRU,LCAFAL
      COMMON IBASE(1)
      PARAMETER (LCATRU=.TRUE.,LCAFAL=.FALSE.)
*
      NAMT=NAMP
      IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         WRITE(HSMG,'(33HLCMDEL: UNABLE TO DELETE RECORD '',A12,4H'' FR,
     1   14HOM A XSM FILE.)') NAMT
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IHEAD).NE.100) THEN
         WRITE(HSMG,'(24HLCDEL: THE LINKED LIST '',3A4,11H'' HAVE THE ,
     1   13HWRONG HEADER.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.2) THEN
         WRITE(HSMG,'(25HLCMDEL: THE LINKED LIST '',3A4,11H'' IS OPEN I,
     1   17HN READ-ONLY MODE.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ENDIF
      CALL LCMVAL(IPLIST,NAMT)
      CALL LCMCAR(NAMT,LCATRU,INAMT)
      IPNODE=IBASE(IPLIST+INEXT)
      IF(IPNODE.EQ.0) GO TO 30
      IPOS=MOD(ABS(INAMT(1)+3*INAMT(2)+5*INAMT(3)),LHASH)
      DO 10 I=IBASE(IPNODE+2+IPOS),1,-1
      IF(INAMT(1).EQ.IBASE(IPNODE+10*(I-1)+JCMT)) THEN
         IF(INAMT(2).EQ.IBASE(IPNODE+10*(I-1)+JCMT+1)) THEN
            IF(INAMT(3).EQ.IBASE(IPNODE+10*(I-1)+JCMT+2)) THEN
               IF(IBASE(IPNODE+10*(I-1)+JJTYP).NE.0) THEN
                  PDATA=IBASE(IPNODE+10*(I-1)+JDATA)
                  CALL RLSARA(IBASE(PDATA))
                  IBASE(IPNODE+10*(I-1)+JDATA)=0
                  IBASE(IPNODE+10*(I-1)+JJLON)=-99
                  IBASE(IPNODE+10*(I-1)+JJTYP)=-99
                  IBASE(IPNODE+10*(I-1)+JCMT)=0
                  IBASE(IPNODE+10*(I-1)+JCMT+1)=0
                  IBASE(IPNODE+10*(I-1)+JCMT+2)=0
                  IF(I.EQ.IBASE(IPNODE+1)) IBASE(IPNODE+1)=I-1
                  RETURN
               ELSE
                  WRITE(HSMG,'(33HLCMDEL: CANNOT DELETE DIRECTORY '',
     1            A12,22H'' IN THE LINKED LIST '',3A4,2H''.)') NAMT,
     2            (IBASE(IPLIST+IHNAM+J),J=0,2)
                  CALL XABORT(HSMG)
               ENDIF
            ENDIF
         ENDIF
      ENDIF
   10 CONTINUE
   30 PTMP=IBASE(IPLIST+IFATH)
      IF(PTMP.EQ.-1) THEN
         TEXT12='/'
      ELSE
         IP=IBASE(IPLIST+IDIR)
         CALL LCMCAR(TEXT12,LCAFAL,IBASE(PTMP+10*(IP-1)+JCMT))
      ENDIF
      WRITE(HSMG,'(30HLCMDEL: UNABLE TO FIND BLOCK '',A12,9H'' INTO DI,
     1 9HRECTORY '',A12,22H'' IN THE LINKED LIST '',3A4,2H''.)') NAMT,
     2 TEXT12,(IBASE(IPLIST+IHNAM+I),I=0,2)
      CALL XABORT(HSMG)
      END
