      SUBROUTINE LCMLEN(IPLIST,NAMP,ILONG,ITYLCM)
*
*-----------------------------------------------------------------------
*
* RETURN THE LENGTH AND TYPE OF A LINKED LIST ENTRY.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LINKED LIST.
*    NAMP : CHARACTER*12 NAME OF THE CURRENT BLOCK.
*
* OUTPUT PARAMETERS:
*  ILONG  : NUMBER OF INFORMATION ELEMENTS POINTED BY THE LCM ENTRY.
*           ILONG=0 IS RETURNED IF THE ENTRY DOES NOT EXISTS.
*  ITYLCM : TYPE OF INFORMATION ELEMENTS POINTED BY THE LCM ENTRY.
*           0: DIRECTORY                1: INTEGER
*           2: SINGLE PRECISION         3: CHARACTER*4
*           4: DOUBLE PRECISION         5: LOGICAL
*           6: COMPLEX                  7: UNDEFINED
*
*------------------------------------- AUTHOR: A. HEBERT ; 28/10/93 ----
*
      PARAMETER (LHASH=251)
      PARAMETER (IHEAD=0,IHNAM=1,INEXT=4,IMODE=9)
      PARAMETER (JJLON=LHASH+3,JJTYP=LHASH+4,JCMT=LHASH+9)
      CHARACTER NAMP*(*),NAMT*12,HSMG*131
      INTEGER INAMT(3)
      LOGICAL LCATRU
      PARAMETER( LCATRU=.TRUE.)
      COMMON IBASE(1)
*
      IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         CALL XSMLEN(IPLIST,NAMP,ILONG,ITYLCM)
         RETURN
      ELSE IF(IBASE(IPLIST+IHEAD).NE.100) THEN
         WRITE(HSMG,'(25HLCMLEN: THE LINKED LIST '',3A4,11H'' HAVE THE ,
     1   13HWRONG HEADER.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(25HLCMLEN: THE LINKED LIST '',3A4,12H'' IS CLOSED.
     1   )') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ENDIF
      NAMT=NAMP
      CALL LCMCAR(NAMT,LCATRU,INAMT)
      IPNODE=IBASE(IPLIST+INEXT)
      IPOS=MOD(ABS(INAMT(1)+3*INAMT(2)+5*INAMT(3)),LHASH)
      DO 10 I=IBASE(IPNODE+2+IPOS),1,-1
      IF(INAMT(1).EQ.IBASE(IPNODE+10*(I-1)+JCMT)) THEN
         IF(INAMT(2).EQ.IBASE(IPNODE+10*(I-1)+JCMT+1)) THEN
            IF(INAMT(3).EQ.IBASE(IPNODE+10*(I-1)+JCMT+2)) THEN
               ILONG=IBASE(IPNODE+10*(I-1)+JJLON)
               ITYLCM=IBASE(IPNODE+10*(I-1)+JJTYP)
               RETURN
            ENDIF
         ENDIF
      ENDIF
   10 CONTINUE
      ILONG=0
      ITYLCM=7
      RETURN
      END
