*DECK DCADIV
      SUBROUTINE DCADIV(DCRES,DCDIV)
C----
C  DOUBLE COMPLEX ALGEBRA SUBROUTINE
C  FIND 1/DCDIV
C  FACTOR
C
C  DCRES=1.0D0/DCDIV
C  WHERE
C    DRES  = DOUBLE COMPLEX RESULT
C    DCABS = DOUBLE COMPLEX INPUT
C----
      IMPLICIT         NONE
      DOUBLE PRECISION DCRES(2),DCDIV(2)
*----
*  LOCAL VARIABLES
*----
      INTEGER          IREAL,IMAGI
      PARAMETER       (IREAL=1,IMAGI=2)
      DOUBLE PRECISION DABS
*----
*  USE DCRES=CONJ(DCINV)/(DCINV*CONJ(DCINV))
*----
      CALL DCAABS(DABS,DCDIV)
      IF(DABS.EQ.0.0D0) THEN
        DCRES(IREAL)=0.0D0
        DCRES(IMAGI)=0.0D0
      ELSE
        DABS=1.0D0/(DABS*DABS)
        DCRES(IREAL)= DABS*DCDIV(IREAL)
        DCRES(IMAGI)=-DABS*DCDIV(IMAGI)
      ENDIF
      RETURN
      END
