*DECK IQSPRN
      SUBROUTINE IQSPRN(TMACRO,IUNIT,NGRP,P00,P01,P10,P11,PB00,PB01,
     1 PB10,PB11,R0CPC,TERM)
C
C     PRINT THE VALUE OF THE REACTIVITY AND GENERATION AS A
C     FUNCTION OF TIME
C
C     TMICRO : TEMPS ECOULE DEPUIS LE DEBUT DE LA PERTURBATION
C              UNE TRANSITOIRE EST COMPOSEE D'UNE SUITE DE
C              PERTURBATIONS
      DOUBLE PRECISION TMICRO
      COMMON BB(1)
      COMMON/CPCOM/DTMACR,DMCM1,IDECR,IBETA,NDG,ITRAN,BETATD,DRHO
       DOUBLE PRECISION PB00(NGRP,NGRP),PB01(NGRP,NGRP),
     1  PB10(NGRP,NGRP),PB11(NGRP,NGRP),
     1  P00(NGRP,NGRP), P01(NGRP,NGRP), P10(NGRP,NGRP),
     1  P11(NGRP,NGRP)
      DOUBLE PRECISION DTMACR,DMCM1,R0CPC(NGRP),TERM(NGRP)
      DOUBLE PRECISION D0,D1,D0D1,D1D1,TEMPA,TEMPB
      DOUBLE PRECISION R0,DERCON
      DOUBLE PRECISION AGEN0,AGEN1,RHO0,RHO1,BETATD,DRHO
      DOUBLE PRECISION RHO,LSTAR,RHOSTR
C DETERMINATION DES FONCTION DU TEMPS
      NSTEP = 10
      WRITE(6,*) ' TIME   REACTIVITY GEN TIME  REACT/GEN TIME'
      DO 999 II=0,NSTEP
      TMICRO = DTMACR/NSTEP*II
      D1 = TMICRO*DMCM1
      D0 = 1.0 - D1
      IF(ITRAN.EQ.2) THEN
        D0D1 = D0*D1
        D1D1 = D1*D1
        TEMPA = 0.0
        TEMPB = 0.0
        DO 100 J=1,NGRP
        DO 100 I=1,NGRP
          TEMPB=PB00(I,J)*D0  +PB01(I,J)*D1  +
     &          PB10(I,J)*D0D1+PB11(I,J)*D1D1+ TEMPB
           TEMPA=P00(I,J)*D0   +P01(I,J)*D1   +
     &           P10(I,J)*D0D1 +P11(I,J)*D1D1 + TEMPA
100     CONTINUE
        DERCON = ( TERM(1)- 1.D0/R0CPC(1) )/DTMACR
        R0     = 1.D0/(1.D0/R0CPC(1) + DERCON*TMICRO)
        RHOSTR =  (TEMPA+BETATD*TEMPB)*R0
        RHO    =  (TEMPA+BETATD*TEMPB-DRHO)/TEMPB
        LSTAR  =  1.D0/(R0*TEMPB)
      ELSE IF(ITRAN.EQ.1) THEN
        TEMPA = 0.0
        TEMPB = 0.0
        DO 110 J=1,NGRP
        DO 110 I=1,NGRP
          TEMPB=PB00(I,J)*D0  +PB01(I,J)*D1  +
     &          PB10(I,J)*D0  +PB11(I,J)*D1  + TEMPB
           TEMPA=P00(I,J)*D0   +P01(I,J)*D1   +
     &           P10(I,J)*D0   +P11(I,J)*D1   + TEMPA
110     CONTINUE
       DERCON = ( TERM(1)- 1.D0/R0CPC(1) )/DTMACR
        R0     = 1.D0/(1.D0/R0CPC(1) + DERCON*TMICRO)
        RHOSTR =  (TEMPA+BETATD*TEMPB)*R0
        RHO    =  (TEMPA+BETATD*TEMPB-DRHO)/TEMPB
        LSTAR  =  1.D0/(R0*TEMPB)
      ELSE IF(ITRAN.EQ.3) THEN
*       COMPUTE INITIAL REACTIVITY AND FINAL REACTIVITY
        AGEN0= 0.D0
        AGEN1= 0.D0
        RHO0 = 0.D0
        RHO1 = 0.D0
        DO 200 J=1,NGRP
        DO 200 I=1,NGRP
          AGEN0=PB00(I,J)     + AGEN0
          AGEN1=PB01(I,J)     + PB11(I,J)     + AGEN1
           RHO0 =P00(I,J)     + RHO0
           RHO1 =P01(I,J)     + P11(I,J)      + RHO1
200     CONTINUE
        RHO0 = (RHO0 + BETATD*AGEN0)/AGEN0
        RHO1 = (RHO1 + BETATD*AGEN1)/AGEN1
        RHO    =  RHO0*D0 + RHO1*D1
        RHOSTR = (RHO0*D0 + RHO1*D1)/TERM(1)
        LSTAR  = TERM(1)/AGEN1
        RHOSTR = (RHO0*D0 + RHO1*D1)/LSTAR
      ENDIF
      WRITE(IUNIT,1000) TMACRO+TMICRO,RHO,LSTAR,RHOSTR
1000  FORMAT(7(3X,E12.5))
999   CONTINUE
      RETURN
      END
