*DECK RFBEXI
      SUBROUTINE RFBEXI(IPRES,NCH,NK,BEXIT,BURN,NS,NN)
*
**********************************************************************
*
*     THIS SUBROUTINE COMPUTES EXIT BURNUP OF EACH CHANNEL
*
*
*-------------------------------------- AUTHOR: E. VARIN  96/07/29 ---
*
      IMPLICIT NONE
*
*  LOCAL VARIABLES
*
      INTEGER I,K,L,IPOST,KC,IPRES,KK
      INTEGER NCH,NK,NS(NCH),NN(NK),NNS
      REAL    BURN(NCH,NK),BEXIT(NCH)
*
      CALL LCMSIX(IPRES,' ',0)
      CALL LCMGET(IPRES,'BURN-DEB',BURN(1,1))
      CALL LCMGET(IPRES,'REFUEL-SCH',NS)
*
*     COMPUTE EXIT BURNUPS
*
      DO 15 I=1,NCH
        KC = 0
        BEXIT(I) = 0.0
        NNS =  ABS(NS(I))
        CALL FLSCHM(NNS,NN,0,NK,I)
*
        DO 16 K=1,NK
          KK = K
          IF( NS(I).LT.0 )THEN
            KK = NK - K + 1
          ENDIF
*
          IPOST = 0
          DO 20 L=1,NK
            IF (NN(L).EQ.K) THEN
               IPOST = L
            ENDIF
   20     CONTINUE
*
          IF (IPOST.EQ.0) THEN
            KC = KC + 1
            BEXIT(I)=BEXIT(I)+BURN(I,KK)
          ENDIF
   16   CONTINUE
        IF( KC.NE.ABS(NS(I)) )CALL XABORT(' SOMETHING WRONG')
        BEXIT(I) = BEXIT(I) /REAL(KC)
   15 CONTINUE
*
      CALL LCMPUT(IPRES,'BURN-EXIT',NCH,2,BEXIT)
*
      RETURN
      END
