      SUBROUTINE LCMNXT(IPLIST,NAMP,NAMLCM,NAMMY,LCM)
*
*-----------------------------------------------------------------------
*
* FIND THE NAME OF THE NEXT BLOCK STORED IN THE ACTIVE DIRECTORY.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE LINKED LIST.
*    NAMP : CHARACTER*12 NAME OF A BLOCK. IF NAMP=' ' AT INPUT, FIND
*           ANY NAME FOR ANY BLOCK STORED IN THIS DIRECTORY.
*
* OUTPUT PARAMETER:
*    NAMP : CHARACTER*12 NAME OF THE NEXT BLOCK. NAMP=' ' FOR AN EMPTY
*           DIRECTORY.
*  NAMLCM : CHARACTER*12 NAME OF THE LINKED LIST.
*   NAMMY : CHARACTER*12 NAME OF THE ACTIVE DIRECTORY.
*     LCM : .TRUE.: LINKED LIST USED; .FALSE.: XSM FILE USED.
*
*------------------------------------- AUTHOR: A. HEBERT ; 28/10/93 ----
*
      PARAMETER (LHASH=251)
      INTEGER PTMP
      PARAMETER (IHEAD=0,IHNAM=1,INEXT=4,IFATH=5,IDIR=6,IMODE=9)
      PARAMETER (JCMT=LHASH+9)
      LOGICAL LCM,LCHECK,LCATRU,LCAFAL
      PARAMETER (LCATRU=.TRUE.,LCAFAL=.FALSE.)
      CHARACTER NAMP*(*),NAMLCM*(*),NAMMY*(*),NAMT*12,HSMG*131,HNAME*12
      INTEGER INAMT(3)
      COMMON IBASE(1)
*
      LCM=(IBASE(IPLIST+IHEAD).EQ.100)
      IF(IBASE(IPLIST+IHEAD).EQ.200) THEN
*        USE A XSM FILE.
         CALL XSMNXT(IPLIST,NAMP,NAMLCM,NAMMY)
         RETURN
      ELSE IF(IBASE(IPLIST+IMODE).EQ.0) THEN
         WRITE(HSMG,'(25HLCMNXT: THE LINKED LIST '',3A4,12H'' IS CLOSED.
     1   )') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ELSE IF(.NOT.LCM) THEN
         WRITE(HSMG,'(25HLCMNXT: THE LINKED LIST '',3A4,11H'' HAVE THE ,
     1   13HWRONG HEADER.)') (IBASE(IPLIST+IHNAM+I),I=0,2)
         CALL XABORT(HSMG)
      ENDIF
      NAMT=NAMP
      CALL LCMCAR(NAMT,LCATRU,INAMT)
      PTMP=IBASE(IPLIST+IFATH)
      IF(PTMP.EQ.-1) THEN
         NAMMY='/'
      ELSE
         IP=IBASE(IPLIST+IDIR)
         CALL LCMCAR(NAMMY,LCAFAL,IBASE(PTMP+10*(IP-1)+JCMT))
      ENDIF
      WRITE(HNAME,'(3A4)') (IBASE(IPLIST+IHNAM+I),I=0,2)
      NAMLCM=HNAME
      IPNODE=IBASE(IPLIST+INEXT)
      IF(NAMT.EQ.' ') THEN
         IF(IPNODE.EQ.0) RETURN
         IREF=0
   10    IREF=IREF+1
         IF(IREF.GT.IBASE(IPNODE+1)) THEN
            NAMP=' '
            RETURN
         ENDIF
         CALL LCMCAR(NAMT,LCAFAL,IBASE(IPNODE+10*(IREF-1)+JCMT))
         IF(NAMT.EQ.' ') GO TO 10
         NAMP=NAMT
         RETURN
      ENDIF
      IF(IPNODE.EQ.0) THEN
         WRITE(HSMG,'(25HLCMNXT: EMPTY DIRECTORY '',A12,10H'' IN THE L,
     1   12HINKED LIST '',3A4,2H''.)') NAMMY,(IBASE(IPLIST+IHNAM+I),
     2   I=0,2)
         CALL XABORT(HSMG)
      ENDIF
      IPOS=MOD(ABS(INAMT(1)+3*INAMT(2)+5*INAMT(3)),LHASH)
      DO 30 I=IBASE(IPNODE+2+IPOS),1,-1
      IREF=I
      IF(INAMT(1).EQ.IBASE(IPNODE+10*(IREF-1)+JCMT)) THEN
         IF(INAMT(2).EQ.IBASE(IPNODE+10*(IREF-1)+JCMT+1)) THEN
            IF(INAMT(3).EQ.IBASE(IPNODE+10*(IREF-1)+JCMT+2)) THEN
               LCHECK=.FALSE.
   20          IF(IREF.LT.IBASE(IPNODE+1)) THEN
                  IREF=IREF+1
               ELSE
                  IF(LCHECK) CALL XABORT('LCMNXT: INFINITE LOOPING(2).')
                  IREF=1
                  LCHECK=.TRUE.
               ENDIF
               IOFSET=IPNODE+10*(IREF-1)+JCMT
               CALL LCMCAR(NAMT,LCAFAL,IBASE(IOFSET))
               IF(NAMT.EQ.' ') GO TO 20
               NAMP=NAMT
               RETURN
            ENDIF
         ENDIF
      ENDIF
   30 CONTINUE
      WRITE(HSMG,'(30HLCMNXT: UNABLE TO FIND BLOCK '',A12,9H'' INTO DI,
     1 9HRECTORY '',A12,22H'' IN THE LINKED LIST '',3A4,2H''.)') NAMT,
     2 NAMMY,(IBASE(IPLIST+IHNAM+I),I=0,2)
      CALL XABORT(HSMG)
      END
