*DECK DCAPOW
      SUBROUTINE DCAPOW(DCRES,DCROOT,DPOW)
C----
C  DOUBLE COMPLEX ALGEBRA SUBROUTINE
C  FIND POWER OF DOUBLE COMPLEX
C
C  DCRES=DCROOT**DPOW
C  WHERE
C    DRES  = DOUBLE COMPLEX RESULT
C    DCABS = DOUBLE COMPLEX INPUT
C----
      IMPLICIT         NONE
      DOUBLE PRECISION DCRES(2),DCROOT(2),DPOW
*----
*  LOCAL VARIABLES
*----
      INTEGER          IREAL,IMAGI
      PARAMETER       (IREAL=1,IMAGI=2)
      DOUBLE PRECISION DABS,DTHT
*----
*  USE DCRES=EXP(DPOW*LOG(DCROOT))
*----
      CALL DCAABS(DABS,DCROOT)
      IF(DABS.EQ.0.0D0) THEN
        DCRES(IREAL)=0.0D0
        DCRES(IMAGI)=0.0D0
      ELSE
        IF(DCROOT(IREAL).LT.0.0D0) THEN
          DTHT=DPOW*ASIN(-DCROOT(IMAGI)/DABS)
          DABS=DABS**DPOW
          IF(DCROOT(IMAGI).LT.0.0D0) THEN
            DCRES(IMAGI)=-DABS*COS(DTHT)
            DCRES(IREAL)=DABS*SIN(DTHT)
          ELSE
            DCRES(IMAGI)=DABS*COS(DTHT)
            DCRES(IREAL)=-DABS*SIN(DTHT)
          ENDIF
        ELSE
          DTHT=DPOW*ASIN(DCROOT(IMAGI)/DABS)
          DABS=DABS**DPOW
          DCRES(IREAL)=DABS*COS(DTHT)
          DCRES(IMAGI)=DABS*SIN(DTHT)
        ENDIF
      ENDIF
      RETURN
      END
